// **********************************************************************************
// begin interface
// this file encoding is UTF-8

// external object
var	g_ext = null;

// ----------------------------------------------------------------------------------
// 対象のIDのURLを既読にする。
// exeのメソッドを呼びます。
function setReadedById(id, deep)
{
	if(g_ext)
	{
		return g_ext.setReadedById(id, deep);
	}
	return false;
}

// ----------------------------------------------------------------------------------
// 対象のURLを既読にする。
// exeのメソッドを呼びます。
function setReadedByUrl(url)
{
	if(g_ext)
	{
		return g_ext.setReadedByUrl(url);
	}
	return -1;
}

// ----------------------------------------------------------------------------------
// 前のバージョンと互換でURLを開く。target=_blankだと新しいウインドウが開くので。
// 無効とするときは、この関数から開かないようにする。
// exeのメソッドを呼びます。
function openCompatible(url)
{
	if(g_ext)
	{
		return g_ext.openCompatible(url);
	}
	return false;
}

// ----------------------------------------------------------------------------------
// 更新通知ウインドウのレイアウトを更新する。
// exeのメソッドを呼びます。
function updateLayout()
{
	if(g_ext)
	{
		return g_ext.updateLayout(1);
	}
	return false;
}

// ----------------------------------------------------------------------------------
// 全て既読にする。
// exeのメソッドを呼びます。
function setAllReaded()
{
	if(g_ext)
	{
		return g_ext.setAllReaded();
	}
	return false;
}

// ----------------------------------------------------------------------------------
// 更新通知ウインドウを閉じる。
// exeのメソッドを呼びます。
function closeWindow()
{
	if(g_ext)
	{
		return g_ext.closeWindow(1);
	}
	return false;
}

// ----------------------------------------------------------------------------------
// 対象のIDから未読数を取得する。
// exeのメソッドを呼びます。
function getNoreadCount(idRoot)
{
	if(g_ext)
	{
		return g_ext.getNoreadCount(idRoot);
	}
	return -1;
}

// ----------------------------------------------------------------------------------
// テンプレートロードイベント
// テンプレートが読み込まれたとき、exeから呼ばれます。
function onTemplateLoad()
{ 
	g_ext = external;
}

// ----------------------------------------------------------------------------------
// テンプレートアンロードイベント
// テンプレートがアンロードされるとき、exeから呼ばれます。
function onTemplateUnload()
{
	g_ext = null;
}

// ----------------------------------------------------------------------------------
// 既読表示にする。
// exeから呼ばれます。
// HTMLの構造を知っている側が処理をします。
function updateReadedById(id, deep)
{
	updateReaded(id, deep);
}




// end interface
// **********************************************************************************



// **********************************************************************************
// begin local

// ----------------------------------------------------------------------------------
// イベントのキャンセル。
function cancelEvent(eventObj)
{
	eventObj.returnValue = false;
}

// ----------------------------------------------------------------------------------
// 対象のIDのURLを既読にして、ノードの表示を更新する。
function setReaded(id, deep)
{
	setReadedById(id, deep);
	updateReaded(id, deep);
}

// ----------------------------------------------------------------------------------
// 自身のノードが最後の子だったとき、親ノードも削除する。
// 戻り値：
// 0：何もしなかった
// 1：親ノードを削除した
// 2：ノードを削除した
function removeNodeWithCheck(subitem, isCheck)
{
	if(subitem)
	{	
		//
		if(isCheck)
		{
			var	subitems = subitem.parentNode;
			var	count = (subitems ? subitems.childNodes.length : 0);
		}
		if(1 == count)
		{
			var item = subitems.parentNode;
			if(item)
			{
				item.removeNode(true);
				return 1;
			}
		}
		else
		{
			subitem.removeNode(true);
			return 2;
		}
	}
	return 0;
}

// ----------------------------------------------------------------------------------
// 未読数テキストの更新。
function updateChildItemCount(item)
{
	var	count = -1;
	if(item)
	{
		count = getNoreadCount(item.id);
		if(count >= 0)
		{
			var nodes = item.getElementsByTagName("span");
			var	countNode = (nodes ? nodes[0] : null);
			if(countNode)
			{
				countNode.innerText = "("+count+"件の未読)";
			}
		}
	}
	return count;
}

// ----------------------------------------------------------------------------------
// サブアイテムノードの表示・非表示のトグル。
function toggleSubitems(id)
{
	var	elem = document.getElementById(id);
	var	nodes = (elem ? elem.getElementsByTagName("div") : null);
	var	subitems = (nodes ? nodes[1] : null);
	if(subitems)
	{
		var	disp = subitems.style.display;
		if(disp == "none")
		{
			subitems.style.display = "block";
		}
		else
		{
			subitems.style.display = "none";
		}
		updateLayout();
		return true;
	}
	return false;
}

// ----------------------------------------------------------------------------------
// 既読でのUI表示更新。
function updateReaded(id, deep)
{
	var	elem = document.getElementById(id);
	if(elem)
	{
		// アイテム要素のとき、サイトのとき
		if(deep || "item" == elem.className)
		{
			updateReadedItem(elem);
		}
		// サブアイテム要素のとき
		else
		{
			updateReadedSubitem(elem);
		}
	}
}

// ----------------------------------------------------------------------------------
// 既読でのUI表示更新。(item)
function updateReadedItem(item)
{
	if(item)
	{
		item.removeNode(true);
		updateLayout();
	}
}

// ----------------------------------------------------------------------------------
// 既読でのUI表示更新。(subitem)
function updateReadedSubitem(subitem)
{
	if(subitem)
	{
		var item = getItem(subitem);
		var ret = removeNodeWithCheck(subitem, true);
		if(ret== 2)
		{
			updateChildItemCount(item);
		}
		if(ret != 0)
		{
			updateLayout();
		}
	}
}

// ----------------------------------------------------------------------------------
// item要素の取得。
function getItem(subitem)
{
	if(subitem)
	{
		var subitems = subitem.parentNode;
		if(subitems)
		{
			return subitems.parentNode;
		}
	}
	return null;
}
